; RLM Calculator

(define (lmcalc)
(set! *resdb*
(dm-open-db "LMcalc" 1))
(frm-popup 5000 handler))

(define handler

  (let ((stack '())
	(vars '())
	(km-pos 0)
	(kmenu '()))

    (define (update)
      (scl-set-val 2002
	(list
	  0
	  (min 0 (- (- (length stack) 5)))
	  0
	  5))
      (stackdisp-update stack)
      (vardisp-update kmenu)
      (fld-set-text 1002 "")
      (frm-set-focus 1002))

(define (push-input)
(if (fld-dirty? 1002)
(set! stack 
(push stack
(string->object
(fld-get-text 1002))))))

(lambda (e . a)
  (case e
    ((menu) (launch))
    ((frm-open) (update))
    ((scl-repeat)
     (let ((id (car a)))
       (case id
	 ((2002)
	  (stackdisp-update stack)
	  #f)
	 (else #f))))

((ctl-select)
(let ((id (car a)))

(cond

((eq? id 2001)      ; ENTER
(set! stack
(if (fld-dirty? 1002)
(push stack
(string->object
(fld-get-text 1002)))
(dup stack)))           
(update))

((and (>= id 2020)
(< id 2026))
(push-input)
(set! stack
(let ((n (- id 2020)))
(if (< n (length vars))
(push stack
(cdr (list-ref vars n)))
stack)))
(update))

((eq? id 2030)
(push-input)
(set! stack 
(uniop
stack
(lambda (x) (* x x))))
(update))

((eq? id 2031)
(push-input)
(set! stack 
(uniop stack sqrt))
(update))

((eq? id 2032)
(push-input)
(set! stack (binop stack expt))
(update))

((eq? id 2033)
(push-input)
(set! stack 
(uniop stack /))
(update))

((eq? id 2040)
(push-input)
(set! stack (binop stack +))
(update))

((eq? id 2043)
(push-input)
(set! stack (binop stack -))
(update))

((eq? id 2041)
(push-input)
(set! stack (binop stack /))
(update))

((eq? id 2042)
(push-input)
(set! stack (binop stack *))
(update))

((eq? id 2044)       ; CHS
(push-input)
(set! stack (uniop stack -))
(update))

((eq? id 2050)      ; DROP
(set! stack
(if (fld-dirty? 1002)
stack
(drop1 stack)))         
(update))

((eq? id 2051)       ; ROLL
(push-input)
(set! stack (roll stack))
(update))

((eq? id 2052)       ; SWAP
(push-input)
(set! stack (swap stack))
(update))

((eq? id 2053)       ; EDIT
(fld-set-text 1002 
(object->string (car stack)))
(set! stack (cdr stack)))

((eq? id 2054)       ; PURGE
(push-input)
(set! vars
(a-purge vars (car stack)))
(set! stack (cdr stack))
(set! kmenu 
(if (> km-pos (length vars))
  '()
  (list-tail vars km-pos)))
(update))

((eq? id 2055)       ; STO
(push-input)
(set! vars
(a-store vars (car stack) (cadr stack)))
(set! stack (cddr stack))
(set! kmenu (list-tail vars km-pos))
(update))

((eq? id 2056)       ; RCL
(push-input)
(set! stack
(push (cdr stack)
(cdr (assoc (car stack) vars))))
(update))

((eq? id 2004)       ;  NEXT
 (set! kmenu
   (if (> (length kmenu) 6)
     (cddddddr kmenu)
     vars))
 (set! km-pos
(if (null? vars)
  0
   (remainder
     (+ km-pos 6)
     (inexact->exact
       (* 6 (ceiling (/ (length vars) 6))) ))))
 (vardisp-update kmenu))

((eq? id 2003)       ;  PREV
 (set! km-pos
(if (null? vars)
    0
   (modulo
     (- km-pos 6)
     (inexact->exact
       (* 6 (ceiling (/ (length vars) 6))) ))))
 (set! kmenu
   (list-tail vars km-pos))
 (vardisp-update kmenu))

(else #f))))
(else #f)))))
