; stack2 - for RLM

(define (copy-tree t)
  (if (pair? t)		; XXX vectors and other non-atoms
    (cons
      (copy-tree (car t))
      (copy-tree (cdr t)))
    t))

(define (copy s)
  (copy-tree s))

(define (push s a)
  (cons a (copy s)))

(define (push! s a)
  (cons a s))

(define (drop1 s)
  (copy (cdr s)))

(define (drop1! s)
  (cdr s))

(define (dup s)
  (cons (car s) (copy s)))

(define (dup! s)
  (cons (car s) s))

(define (over s)
  (push s (cadr s)))

(define (swap s)
  (cons (cadr  s) 
           (push (cddr s) (car s))))

(define (rot s)
  (cons (caddr  s) 
           (cons (car s)
                   (push (cdddr s) (cadr s)))))

(define (pick! s n)
  (let ((t (list-tail s (- n 1))))
    (cons (car t) s)))

(define (roll s)
  (let* ((n (car s))
         (s (cdr s))
         (e (list-tail s (- n 2)))
         (t (cdr e)))
    (set-cdr! e (cdr t))
    (cons (car t) s)))

(define (binop s f)
  (push
    (cddr s)
    (apply f (list (cadr s)
		   (car s)))))

(define (uniop s f)
  (push
    (cdr s)
    (f (car s))))

(define (polyop n s f)
  (push
    (list-tail s n)
    (apply f (take s n))))
